// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ffmpeg_image_transport_msgs:msg/FFMPEGPacket.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "ffmpeg_image_transport_msgs/msg/ffmpeg_packet.hpp"


#ifndef FFMPEG_IMAGE_TRANSPORT_MSGS__MSG__DETAIL__FFMPEG_PACKET__TRAITS_HPP_
#define FFMPEG_IMAGE_TRANSPORT_MSGS__MSG__DETAIL__FFMPEG_PACKET__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ffmpeg_image_transport_msgs/msg/detail/ffmpeg_packet__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace ffmpeg_image_transport_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const FFMPEGPacket & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: width
  {
    out << "width: ";
    rosidl_generator_traits::value_to_yaml(msg.width, out);
    out << ", ";
  }

  // member: height
  {
    out << "height: ";
    rosidl_generator_traits::value_to_yaml(msg.height, out);
    out << ", ";
  }

  // member: encoding
  {
    out << "encoding: ";
    rosidl_generator_traits::value_to_yaml(msg.encoding, out);
    out << ", ";
  }

  // member: pts
  {
    out << "pts: ";
    rosidl_generator_traits::value_to_yaml(msg.pts, out);
    out << ", ";
  }

  // member: flags
  {
    out << "flags: ";
    rosidl_generator_traits::value_to_yaml(msg.flags, out);
    out << ", ";
  }

  // member: is_bigendian
  {
    out << "is_bigendian: ";
    rosidl_generator_traits::value_to_yaml(msg.is_bigendian, out);
    out << ", ";
  }

  // member: data
  {
    if (msg.data.size() == 0) {
      out << "data: []";
    } else {
      out << "data: [";
      size_t pending_items = msg.data.size();
      for (auto item : msg.data) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const FFMPEGPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "width: ";
    rosidl_generator_traits::value_to_yaml(msg.width, out);
    out << "\n";
  }

  // member: height
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "height: ";
    rosidl_generator_traits::value_to_yaml(msg.height, out);
    out << "\n";
  }

  // member: encoding
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "encoding: ";
    rosidl_generator_traits::value_to_yaml(msg.encoding, out);
    out << "\n";
  }

  // member: pts
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pts: ";
    rosidl_generator_traits::value_to_yaml(msg.pts, out);
    out << "\n";
  }

  // member: flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "flags: ";
    rosidl_generator_traits::value_to_yaml(msg.flags, out);
    out << "\n";
  }

  // member: is_bigendian
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_bigendian: ";
    rosidl_generator_traits::value_to_yaml(msg.is_bigendian, out);
    out << "\n";
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const FFMPEGPacket & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace ffmpeg_image_transport_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ffmpeg_image_transport_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ffmpeg_image_transport_msgs::msg::FFMPEGPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  ffmpeg_image_transport_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ffmpeg_image_transport_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const ffmpeg_image_transport_msgs::msg::FFMPEGPacket & msg)
{
  return ffmpeg_image_transport_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<ffmpeg_image_transport_msgs::msg::FFMPEGPacket>()
{
  return "ffmpeg_image_transport_msgs::msg::FFMPEGPacket";
}

template<>
inline const char * name<ffmpeg_image_transport_msgs::msg::FFMPEGPacket>()
{
  return "ffmpeg_image_transport_msgs/msg/FFMPEGPacket";
}

template<>
struct has_fixed_size<ffmpeg_image_transport_msgs::msg::FFMPEGPacket>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ffmpeg_image_transport_msgs::msg::FFMPEGPacket>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<ffmpeg_image_transport_msgs::msg::FFMPEGPacket>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // FFMPEG_IMAGE_TRANSPORT_MSGS__MSG__DETAIL__FFMPEG_PACKET__TRAITS_HPP_
